/*
 * filter_db2.cpp
 *
 *  Created on: 16.12.2017

Discrete Wavelet Transform example,     (c) 2017, Piotr Romaniuk, ELESOFTROM

All rights reserved

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the copyright holder nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#if 0 //determined in QPU
const float _const[]=//{ 5, 10, 15, 13,   17,19,23,29,  31,35,8,6,  3,2,14,7 //const_H4+
        			//};

        {
        /*H12*/ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0,
        /*L4 */ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1,
        /*L8 */ 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
        /*M4 */ 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0,
        };
#endif

const unsigned int _indexes[]={
        /*I0 */  0,  2,  4,  6,  8, 10, 12, 14,  0,  4,  8, 12,  4,  8, 12, 16,
        /*I1 */  1,  3,  5,  7,  9, 11, 13, 15,  1,  5,  9, 13,  5,  9, 13, 17,
        /*I2 */  2,  4,  6,  8, 10, 12, 14, 16,  2,  6, 10, 14,  6, 10, 14, 18,
        /*I3 */  3,  5,  7,  9, 11, 13, 15, 17,  3,  7, 11, 15,  7, 11, 15, 19,
        /*I4 */  0,  0,  0,  0,  0,  0,  0,  0,  8, 12, 16, 20,  9, 13, 17, 21,
        /*I5 */  0,  8,  0,  8,  4, 12,  4, 12,  8, 16,  8, 16, 12, 20, 12, 20,
        /*I6 */  1,  9,  1,  9,  5, 13,  5, 13,  9, 17,  9, 17, 13, 21, 13, 21,
        /*I7 */  2, 10,  2, 10,  6, 14,  6, 14, 10, 18, 10, 18, 14, 22, 14, 22,
        /*I8 */  3, 11,  3, 11,  7, 15,  7, 15, 11, 19, 11, 19, 15, 23, 15, 23,
        /*I9 */ 16, 24, 16, 24, 17, 25, 17, 25, 18, 26, 18, 26, 19, 27, 19, 27,
        /*I10*/ 20, 28, 20, 28, 21, 29, 21, 29,  0,  0,  0,  0,  0,  0,  0,  0,
		/*I11*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 //I11 is not used, but added for alignment
        };

const float _filter[]={
        /*F0 */ -0.12941, -0.12941, -0.12941, -0.12941, -0.12941, -0.12941, -0.12941, -0.12941, -0.06250, -0.06250, -0.06250, -0.06250,  0.35377,  0.35377,  0.35377,  0.35377,
        /*F1 */ -0.22414, -0.22414, -0.22414, -0.22414, -0.22414, -0.22414, -0.22414, -0.22414, -0.10825, -0.10825, -0.10825, -0.10825,  0.72877,  0.72877,  0.72877,  0.72877,
        /*F2 */  0.83652,  0.83652,  0.83652,  0.83652,  0.83652,  0.83652,  0.83652,  0.83652, -0.13726, -0.13726, -0.13726, -0.13726, -0.04575, -0.04575, -0.04575, -0.04575,
        /*F3 */ -0.48296, -0.48296, -0.48296, -0.48296, -0.48296, -0.48296, -0.48296, -0.48296, -0.17075, -0.17075, -0.17075, -0.17075, -0.51226, -0.51226, -0.51226, -0.51226,
        /*F4 */  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000, -0.10825, -0.10825, -0.10825, -0.10825,  0.06250,  0.06250,  0.06250,  0.06250,
        /*F5 */ -0.03018, -0.03018,  0.11265,  0.11265, -0.09055, -0.09055,  0.33795,  0.33795,  0.13258,  0.13258,  0.28567,  0.28567,  0.14125,  0.14125,  0.01184,  0.01184,
        /*F6 */ -0.05228, -0.05228,  0.19512,  0.19512, -0.10081, -0.10081,  0.37623,  0.37623,  0.31803,  0.31803,  0.16493,  0.16493, -0.13258, -0.13258, -0.02051, -0.02051,
        /*F7 */ -0.06629, -0.06629,  0.24740,  0.24740, -0.11323, -0.11323,  0.42259,  0.42259,  0.43126,  0.43126,  0.10456,  0.10456, -0.25766, -0.25766, -0.06904, -0.06904,
        /*F8 */ -0.08247, -0.08247,  0.30777,  0.30777, -0.12507, -0.12507,  0.46679,  0.46679,  0.56385,  0.56385,  0.02802,  0.02802, -0.42259, -0.42259, -0.11323, -0.11323,
        /*F9 */ -0.16710, -0.16710, -0.04477, -0.04477, -0.02426, -0.02426, -0.00650, -0.00650,  0.00592,  0.00592,  0.00159,  0.00159,  0.06629,  0.06629,  0.01776,  0.01776,
        /*F10*/  0.01401,  0.01401,  0.00375,  0.00375, -0.00809, -0.00809, -0.00217, -0.00217,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000,  0.00000, 0.00000

		};

void filter_load( unsigned char * filter_buffer )
{
	int ix;
	unsigned char * ptr = filter_buffer;

	//packing I vectors into 32 bits [a,b,c,d]
	for(ix=0;ix<sizeof(_indexes)/sizeof(_indexes[0]);ix+=64 /*each 4 vectors I */){
		const unsigned int *a = &_indexes[ix];//I0, etc.
		const unsigned int *b = &_indexes[ix+16];//I1
		const unsigned int *c = &_indexes[ix+32];//I2
		const unsigned int *d = &_indexes[ix+48];//I3
		int elem;
		for(elem=0; elem<16; elem++){
			*ptr++ = a[elem];// |I0.0|I1.0|I2.0|I3.0| I0.1|I1.1|I2.1|I3.1|...
			*ptr++ = b[elem];
			*ptr++ = c[elem];
			*ptr++ = d[elem];
		}
	}

	for(ix=0;ix<sizeof(_filter)/sizeof(_filter[0]);ix++){
	        *(float*)ptr = _filter[ix];
	        ptr+=sizeof(_filter[0]);
	}

}
